﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using BusinessIntelligenceToolkit.Controls.ContainerGenerators;

namespace BusinessIntelligenceToolkit.Controls
{
    public class BitStackPanel : Panel
    {
        private ListCollectionView _listCollectionView;

        public BitStackPanel()
        {
            SizeChanged += new SizeChangedEventHandler(BitStackPanel_SizeChanged);
        }

        void BitStackPanel_SizeChanged(object sender, SizeChangedEventArgs e)
        {

        }

        protected override Size MeasureOverride(Size size)
        {
             Debug.WriteLine("Measure");
            var desiredSize = MeasureVertically(size);
            return desiredSize;
        }

        protected override Size ArrangeOverride(Size arrangeSize)
        {
             Debug.WriteLine("Arrange");
            var desiredSize = ArrangeVertically(arrangeSize);
            return desiredSize;
        }

        private int _minimumLogicalNegativeOffset = -5;
        private int _maximumLogicalPositiveOffset = 5;
        public bool FromBottom { get; set; }
        private Size MeasureVertically(Size size)
        {
            if (CollectionView == null || CollectionView.Count == 0)
            {
                return size;
            }

            if(ScrollViewer.IsScrolling)
            FromBottom = false;
            //if (ScrollViewer.IsHeightChanged)
            //{
                //FromBottom =
                //    Children.Cast<UIElement>().Any(
                //        x =>
                //        {
                //            var t = x.TranslatePoint(new Point(0, x.DesiredSize.Height), this).Y;



                //            var containsLast = ContainerGenerator.ContainerContainsEqualData(x,
                //                                                           CollectionView.GetItemAt(
                //                                                               CollectionView.Count - 1))
                //             ;
                //            //if (containsLast && t <= size.Height)
                //            //{
                //            //    Debug.WriteLine("-------------------");
                //            //    foreach (ContentPresenter contentPresenter in Children)
                //            //    {
                //            //        Debug.WriteLine(contentPresenter.Content);
                //            //    }
                //            //    Debug.WriteLine(t);
                //            //    Debug.WriteLine("-------------------");

                //            //}
                //            return containsLast && t <= size.Height;
                //        }

                //        );
           // }

            if (ScrollViewer.IsHeightChanged)
            {
                Debug.WriteLine("HERE");
                // ClearChildrenToReuse(0);
                double pvY = size.Height 
                    //- ScrollViewer.Offset
                    ;
                var actLogIndex = CollectionView.Count - 1;
                var actViewportY = Children.Count - 1;
                ContainersInViewport = 0;
                while (pvY >= 0)
                {
                    UIElement container = GetContainerFromViewport(actViewportY, actLogIndex);
                    actViewportY--;
                    actLogIndex--;
                    ContainersInViewport++;
                    container.Measure(new Size(Double.PositiveInfinity, Double.PositiveInfinity));
                    pvY -= container.DesiredSize.Height;
                }

                // ScrollViewer.VerticalScrollBar.Value = ScrollViewer.VerticalScrollBar.Maximum;

                // Debug.WriteLine(ScrollViewer.VerticalScrollBar.Maximum);
                IsLastSnaped = true;
                return new Size(Children.Count > 0 ? Children.Cast<UIElement>().Max(x => x.DesiredSize.Width) : size.Width, size.Height); ;
            }

            // initializes actual offset
            double actualOffset;
            if (Offset < _minimumLogicalNegativeOffset)
            {
                actualOffset = _minimumLogicalNegativeOffset;
            }
            else if (Offset > CollectionView.Count + _maximumLogicalPositiveOffset)
            {
                actualOffset = CollectionView.Count + _maximumLogicalPositiveOffset;
            }
            else
            {
                actualOffset = Offset;
            }





            int logicalStartIndex = (int)Math.Floor(Offset);

            int firstItemIndex = logicalStartIndex < 0 || logicalStartIndex >= CollectionView.Count ? 0 : logicalStartIndex;
            UIElement firstChild = GetContainerFromViewport(0, firstItemIndex);

            Size defaultSize = GetDefaultSize();

            // initializes physicalViewportY
            double physicalOffset = (Offset - Math.Floor(Offset)) * defaultSize.Height;
            double physicalViewportY = 0.0;
            if (actualOffset < 0 || actualOffset > CollectionView.Count)
            {
                physicalViewportY = defaultSize.Height - physicalOffset;
            }
            else
            {
                physicalViewportY = firstChild.DesiredSize.Height - physicalOffset;
            }

            // lazy children adding
            int actualLogicalIndex = firstItemIndex + 1;
            //  int actualViewportIndex = 1;
            ActualViewportIndex = 1;
            //Debug.WriteLine("---------------------------------");

            UIElement lastContainer = firstChild;
            ContainersInViewport = 0;
            if (Math.Floor(physicalViewportY) > 0)
            {
                ContainersInViewport++;
            }
            while (physicalViewportY < size.Height && actualLogicalIndex < CollectionView.Count)
            {
                lastContainer = GetContainerFromViewport(ActualViewportIndex, actualLogicalIndex);
                // Debug.WriteLine((container as ContentPresenter).Content);
                ActualViewportIndex++;
                actualLogicalIndex++;
                lastContainer.Measure(new Size(Double.PositiveInfinity, Double.PositiveInfinity));
                physicalViewportY += lastContainer.DesiredSize.Height;
                if (physicalViewportY >= 0)
                {
                    ContainersInViewport++;
                }
            }


            ClearChildrenToReuse(ActualViewportIndex);

            if (ScrollViewer.VerticalScrollBar.Maximum == 0)
            {
                ScrollViewer.VerticalScrollBar.Maximum = CollectionView.Count - ActualViewportIndex;
            }
            //else
            //    if (
            //        //     actualLogicalIndex == CollectionView.Count -1 
            //        //    &&
            //    physicalViewportY > size.Height
            //    && Offset == ScrollViewer.VerticalScrollBar.Maximum)
            //    {
            //        //ScrollViewer.VerticalScrollBar.Maximum = CollectionView.Count - actualViewportIndex + 1;
            //        ScrollViewer.VerticalScrollBar.Maximum += 1;
            //        offsettToLast = (physicalViewportY - size.Height)/lastContainer.DesiredSize.Height;
            //    }
            //Debug.WriteLine(offsettToLast);
            //Debug.WriteLine(actualLogicalIndex + " " + physicalViewportY + " " + size.Height);
            //if (actualLogicalIndex >= CollectionView.Count - 1 && physicalViewportY <= size.Height)
            //{
            //    _fromLast = true;
            //}
            //else
            //{
            //    ScrollViewer.VerticalScrollBar.Maximum = CollectionView.Count - actualViewportIndex + 1;
            //}
            // Debug.WriteLine(_fromLast);
            // IsLastSnaped = false;
            // ScrollViewer.VerticalScrollBar.Maximum = CollectionView.Count - ActualViewportIndex;

            if (actualLogicalIndex == CollectionView.Count
                && Math.Floor(physicalViewportY) > size.Height
                && ScrollViewer.VerticalScrollBar.Maximum != CollectionView.Count - ContainersInViewport + 1)
            {
                //Debug.WriteLine("RAISED");
                // RaiseLastNotFit();
                Raised = true;
                //Debug.WriteLine(ScrollViewer.VerticalScrollBar.Maximum);
                //  ScrollViewer.VerticalScrollBar.Maximum = ScrollViewer.VerticalScrollBar.Maximum+1;
            }

            //IsLastSnaped = false;
            //if(IsScrolling)
            //IsLastSnaped = actualLogicalIndex == CollectionView.Count
            //+1
            //|| ((actualLogicalIndex == CollectionView.Count )
            //&& physicalViewportY <= size.Height)
            ;

            //if ((actualOffset == ScrollViewer.VerticalScrollBar.Maximum
            //    && !IsScrolling
            //    && physicalViewportY > size.Height)
            //    ||
            //    (
            //    actualOffset == ScrollViewer.VerticalScrollBar.Maximum
            //    && physicalViewportY + lastContainer.DesiredSize.Height < size.Height
            //    ))





            return new Size(Children.Count > 0 ? Children.Cast<UIElement>().Max(x => x.DesiredSize.Width) : size.Width, size.Height);
        }

        private Size ArrangeVertically(Size size)
        {
            if (CollectionView == null || CollectionView.Count == 0)
            {
                return size;
            }

            double offset = Offset > 0 ? (Offset - (int)Math.Floor(Offset)) : Offset;

            

            // var lastInViewport = Offset + unclearChildren.Count() > CollectionView.Count;
            Debug.WriteLine(FromBottom);
            var fromBottom = false;
            if (ScrollViewer.IsHeightChanged)
            {
                fromBottom =
                    Children.Cast<UIElement>().Any(
                        x =>
                        {
                            var t = x.TranslatePoint(new Point(0, x.DesiredSize.Height), this).Y;



                            var containsLast = ContainerGenerator.ContainerContainsEqualData(x,
                                                                           CollectionView.GetItemAt(
                                                                               CollectionView.Count - 1))
                             ;
                            //if (containsLast && t <= size.Height)
                            //{
                            //    Debug.WriteLine("-------------------");
                            //    foreach (ContentPresenter contentPresenter in Children)
                            //    {
                            //        Debug.WriteLine(contentPresenter.Content);
                            //    }
                            //    Debug.WriteLine(t);
                            //    Debug.WriteLine("-------------------");

                            //}
                            return containsLast && Math.Floor(t) <= size.Height;
                        }

                        );
            }

            if (ScrollViewer.IsHeightChanged)
            //if (_fromLast)
            {
                // Debug.WriteLine("HERE");
                //var height = unclearChildren.Sum(
                //    x => x.DesiredSize.Height);
                //var notFitSize = height - size.Height;
                //var nf = offset == 0
                //    ? -1 * notFitSize
                //    : -1 * offset * (notFitSize);
                //double pvY = 0;

                //for (int i = 0; i < Children.Count; i++)
                //{
                //    Children[i].Arrange(new Rect(0, pvY + nf,
                //                                 Math.Max(size.Width, Children[i].DesiredSize.Width),
                //                                 Children[i].DesiredSize.Height));
                //    Children[i].SetValue(PhysicalOffsetProperty, pvY + nf);
                //    pvY += Children[i].DesiredSize.Height;
                //}

                // var unclearChildren = Children.Cast<UIElement>().Where(x => !ContainerGenerator.IsContainerClear(x)).ToList();
                var unclearChildren = Children;
                double pvY = size.Height 
                    //- ScrollViewer.Offset
                    ;
                int currentItemIndex = unclearChildren.Count - 1;
                while (currentItemIndex >= 0)
                {
                    pvY -= unclearChildren[currentItemIndex].DesiredSize.Height;
                    unclearChildren[currentItemIndex].Arrange(new Rect(0, pvY,
                                                 Math.Max(size.Width, unclearChildren[currentItemIndex].DesiredSize.Width),
                                                 unclearChildren[currentItemIndex].DesiredSize.Height));
                    currentItemIndex--;
                }

                return new Size(Children.Count > 0 ? Children.Cast<UIElement>().Max(x => x.DesiredSize.Width) : size.Width, size.Height);
            }

            Size defaultSize = GetDefaultSize();
            int logicalStartIndex = (int)Math.Floor(Offset);

            // initializes physicalViewportY
            //double po = (double) Children[0].GetValue(PhysicalOffsetProperty);
            double physicalOffset =
                //double.IsNaN(po) ?
                -1 * offset * defaultSize.Height
                //: offset * po
                ;

            double physicalViewportY = 0.0;




            Children[0].Arrange(new Rect(0, physicalViewportY + physicalOffset, Math.Max(size.Width, Children[0].DesiredSize.Width), Children[0].DesiredSize.Height));
            // Children[0].SetValue(PhysicalOffsetProperty, double.NaN);
            physicalViewportY += Children[0].DesiredSize.Height + (physicalOffset);

            for (int i = 1; i < Children.Count; i++)
            {
                Children[i].Arrange(new Rect(0, physicalViewportY, Math.Max(size.Width, Children[i].DesiredSize.Width), Children[i].DesiredSize.Height));
                physicalViewportY += Children[i].DesiredSize.Height;
            }

            return new Size(Children.Count > 0 ? Children.Cast<UIElement>().Max(x => x.DesiredSize.Width) : size.Width, size.Height);
        }

        private void ClearChildrenToReuse(int from)
        {
            // clear containers to reuse
            for (int i = from; i < Children.Count; i++)
            {
                ContainerGenerator.ClearContainer(Children[i]);
            }
        }

        private Size GetDefaultSize()
        {
            int logicalStartIndex = (int)Math.Floor(Offset);

            int firstItemIndex = logicalStartIndex < 0 || logicalStartIndex >= CollectionView.Count ? 0 : logicalStartIndex;
            // calculate size of the first child
            // it will be considered as default item size


            // Debug.WriteLine(firstItemIndex);
            UIElement firstChild = GetContainerFromViewport(0, firstItemIndex);
            firstChild.Measure(new Size(Double.PositiveInfinity, Double.PositiveInfinity));
            Size defaultSize = firstChild.DesiredSize;
            return defaultSize;
        }

        private UIElement GetContainerFromViewport(int viewportIndex, int logicalIndex)
        {
            if (viewportIndex >= Children.Count)
            {
                for (int i = Children.Count; i <= viewportIndex; i++)
                {
                    UIElement container = ContainerGenerator.CreateContainer();
                    Children.Add(container);
                    object data = _listCollectionView.GetItemAt(logicalIndex);
                    ContainerGenerator.PrepareContainerForItem(container, data);
                }
            }
            else if (viewportIndex < 0)
            {
                object data = _listCollectionView.GetItemAt(logicalIndex);
                UIElement container = ContainerGenerator.CreateContainer();
                Children.Insert(0, container);
                ContainerGenerator.PrepareContainerForItem(container, data);
                return container;
            }
            else
            {
                object data = _listCollectionView.GetItemAt(logicalIndex);

                ContainerGenerator.PrepareContainerForItem(Children[viewportIndex], data);
            }
            return Children[viewportIndex];
        }


        private static void OnCollectionViewChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            BitStackPanel instance = d as BitStackPanel;
            instance._listCollectionView = instance.CollectionView as ListCollectionView;
        }

        private static object OnCoerceCollectionView(DependencyObject d, object basevalue)
        {
            BitStackPanel instance = d as BitStackPanel;
            if (ContainerGeneratorProperty == null)
            {
                return instance.CollectionView;
            }

            return basevalue;
        }

        private static void OnContainerGeneratorChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            BitStackPanel instance = d as BitStackPanel;
            instance.CoerceValue(CollectionViewProperty);
        }

        private static object OnCoerceContainerGenerator(DependencyObject d, object basevalue)
        {
            BitStackPanel instance = d as BitStackPanel;
            return basevalue;
        }

        public Orientation Orientation
        {
            get { return (Orientation)GetValue(OrientationProperty); }
            set { SetValue(OrientationProperty, value); }
        }

        public double Offset
        {
            get { return (double)GetValue(OffsetProperty); }
            set { SetValue(OffsetProperty, value); }
        }

        public static readonly DependencyProperty OrientationProperty =
            DependencyProperty.Register("Orientation", typeof(Orientation), typeof(BitStackPanel), new PropertyMetadata(Orientation.Vertical));

        public static readonly DependencyProperty OffsetProperty =
            DependencyProperty.Register("Offset", typeof(double),
            typeof(BitStackPanel),
            new FrameworkPropertyMetadata(default(double),
                FrameworkPropertyMetadataOptions.AffectsArrange
           |
            FrameworkPropertyMetadataOptions.AffectsMeasure
                ));

        public static readonly DependencyProperty ContainerGeneratorProperty =
            DependencyProperty.Register("ContainerGenerator", typeof(IContainerGenerator), typeof(BitStackPanel), new PropertyMetadata(default(IContainerGenerator), OnContainerGeneratorChanged, OnCoerceContainerGenerator));


        public IContainerGenerator ContainerGenerator
        {
            get { return (IContainerGenerator)GetValue(ContainerGeneratorProperty); }
            set { SetValue(ContainerGeneratorProperty, value); }
        }

        public static readonly DependencyProperty CollectionViewProperty =
            DependencyProperty.Register("CollectionView", typeof(ListCollectionView), typeof(BitStackPanel), new FrameworkPropertyMetadata(default(ICollectionView),
                FrameworkPropertyMetadataOptions.AffectsArrange
                |
                FrameworkPropertyMetadataOptions.AffectsMeasure
                , OnCollectionViewChanged, OnCoerceCollectionView));

        public ListCollectionView CollectionView
        {
            get { return (ListCollectionView)GetValue(CollectionViewProperty); }
            set { SetValue(CollectionViewProperty, value); }
        }

        public static readonly DependencyProperty ScrollViewerProperty =
            DependencyProperty.Register("ScrollViewer", typeof(BitScrollViewer), typeof(BitStackPanel), new PropertyMetadata(default(BitScrollViewer)));

        public BitScrollViewer ScrollViewer
        {
            get { return (BitScrollViewer)GetValue(ScrollViewerProperty); }
            set { SetValue(ScrollViewerProperty, value); }
        }

        public static readonly DependencyProperty PhysicalOffsetProperty =
            DependencyProperty.RegisterAttached("PhysicalOffset", typeof(double), typeof(BitStackPanel), new PropertyMetadata(double.NaN));

        public static void SetPhysicalOffset(UIElement element, double value)
        {
            element.SetValue(PhysicalOffsetProperty, value);
        }

        public static double GetPhysicalOffset(UIElement element)
        {
            return (double)element.GetValue(PhysicalOffsetProperty);
        }

        public static readonly DependencyProperty LogicalIndexProperty =
            DependencyProperty.RegisterAttached("LogicalIndex", typeof(Int32), typeof(BitStackPanel), new PropertyMetadata(default(Int32)));

        public static void SetLogicalIndex(UIElement element, Int32 value)
        {
            element.SetValue(LogicalIndexProperty, value);
        }

        public static Int32 GetLogicalIndex(UIElement element)
        {
            return (Int32)element.GetValue(LogicalIndexProperty);
        }

        public bool IsScrolling { get { return ScrollViewer.IsScrolling; } }
        public bool IsLastSnaped { get; set; }

        public int ContainersInViewport { get; set; }
        public int ActualViewportIndex { get; set; }
        public bool Raised { get; set; }

        public event EventHandler LstNotFit;
        private void RaiseLastNotFit()
        {
            if (LstNotFit != null)
            {
                LstNotFit(this, EventArgs.Empty);
            }
        }
    }

    public class SnapLastItem
    {

    }
}